"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _ScheduleConfig = require("./ScheduleConfig");
var _constants = require("./constants");
var _locale = require("../../locale");
var _CollectionBlockInitializer = require("../../components/CollectionBlockInitializer");
var _variable = require("../../variable");
var _FieldsSelect = require("../../components/FieldsSelect");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _default = {
  title: `{{t("Schedule event", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'schedule',
  fieldset: {
    config: {
      type: 'void',
      'x-component': 'ScheduleConfig',
      'x-component-props': {}
    }
  },
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    ScheduleConfig: _ScheduleConfig.ScheduleConfig,
    FieldsSelect: _FieldsSelect.FieldsSelect
  },
  useVariables(config, opts) {
    var _config$appends;
    const compile = (0, _client().useCompile)();
    const _useCollectionManager = (0, _client().useCollectionManager)(),
      getCollectionFields = _useCollectionManager.getCollectionFields;
    const options = [];
    if (!(opts === null || opts === void 0 ? void 0 : opts.types) || opts.types.includes('date')) {
      options.push({
        key: 'date',
        value: 'date',
        label: (0, _locale.lang)('Trigger time')
      });
    }
    const depth = ((_config$appends = config.appends) === null || _config$appends === void 0 ? void 0 : _config$appends.length) ? config.appends.reduce((max, item) => Math.max(max, item.split('.').length), 1) + 1 : 1;
    const fieldOptions = (0, _variable.getCollectionFieldOptions)(_objectSpread(_objectSpread({
      depth
    }, opts), {}, {
      collection: config.collection,
      compile,
      getCollectionFields
    }));
    if (config.mode === _constants.SCHEDULE_MODE.COLLECTION_FIELD) {
      if (fieldOptions.length) {
        options.push({
          key: 'data',
          value: 'data',
          label: (0, _locale.lang)('Trigger data'),
          children: fieldOptions
        });
      }
    }
    return options;
  },
  useInitializers(config) {
    if (!config.collection) {
      return null;
    }
    return {
      type: 'item',
      title: `{{t("Trigger data", { ns: "${_locale.NAMESPACE}" })}}`,
      component: _CollectionBlockInitializer.CollectionBlockInitializer,
      collection: config.collection,
      dataSource: '{{$context.data}}'
    };
  },
  initializers: {}
};
exports.default = _default;